UFF/BondStretch.h
Go to the documentation of this file.
//
// Copyright (C) 2004-2006 Rational Discovery LLC
//
// @@ All Rights Reserved @@
// This file is part of the RDKit.
// The contents are covered by the terms of the BSD license
// which is included in the file license.txt, found at the root
// of the RDKit source tree.
//
#ifndef __RD_BONDSTRETCH_H__
#define __RD_BONDSTRETCH_H__
#include <ForceField/Contrib.h>
namespace ForceFields {
namespace UFF {
class AtomicParams;
//! The bond-stretch term for the Universal Force Field
class BondStretchContrib : public ForceFieldContrib {
public:
BondStretchContrib() : d_end1Idx(-1), d_end2Idx(-1) {};
//! Constructor
/*!
\param owner pointer to the owning ForceField
\param idx1 index of end1 in the ForceField's positions
\param idx2 index of end2 in the ForceField's positions
\param bondOrder order of the bond (as a double)
\param end1Params pointer to the parameters for end1
\param end2Params pointer to the parameters for end2
*/
BondStretchContrib(ForceField *owner,unsigned int idx1,unsigned int idx2,
double bondOrder,
const AtomicParams *end1Params,
const AtomicParams *end2Params);
double getEnergy(double *pos) const;
void getGrad(double *pos,double *grad) const;
virtual BondStretchContrib *copy() const { return new BondStretchContrib(*this); };
private:
int d_end1Idx,d_end2Idx; //!< indices of end points
double d_restLen; //!< rest length of the bond
double d_forceConstant; //!< force constant of the bond
};
namespace Utils {
//! calculates and returns the UFF rest length for a bond
/*!
\param bondOrder the order of the bond (as a double)
\param end1Params pointer to the parameters for end1
\param end2Params pointer to the parameters for end2
\return the rest length
*/
double calcBondRestLength(double bondOrder,
const AtomicParams *end1Params,
const AtomicParams *end2Params);
//! calculates and returns the UFF force constant for a bond
/*!
\param restLength the rest length of the bond
\param end1Params pointer to the parameters for end1
\param end2Params pointer to the parameters for end2
\return the force constant
*/
double calcBondForceConstant(double restLength,
const AtomicParams *end1Params,
const AtomicParams *end2Params);
}
}
}
#endif
ForceFields::UFF::AtomicParams
class to store atomic parameters for the Universal Force Field
Definition: UFF/Params.h:72
ForceFields::UFF::BondStretchContrib
The bond-stretch term for the Universal Force Field.
Definition: UFF/BondStretch.h:19
ForceFields::UFF::Utils::calcBondRestLength
double calcBondRestLength(double bondOrder, const AtomicParams *end1Params, const AtomicParams *end2Params)
calculates and returns the UFF rest length for a bond
ForceFields::ForceFieldContrib
abstract base class for contributions to ForceFields
Definition: Contrib.h:17
ForceFields::UFF::BondStretchContrib::getGrad
void getGrad(double *pos, double *grad) const
calculates our contribution to the gradients of a position
ForceFields::UFF::BondStretchContrib::copy
virtual BondStretchContrib * copy() const
return a copy
Definition: UFF/BondStretch.h:41
Contrib.h
ForceFields
Definition: MMFF/Builder.h:22
ForceFields::UFF::BondStretchContrib::getEnergy
double getEnergy(double *pos) const
returns our contribution to the energy of a position
ForceFields::UFF::BondStretchContrib::BondStretchContrib
BondStretchContrib()
Definition: UFF/BondStretch.h:21
ForceFields::ForceField
A class to store forcefields and handle minimization.
Definition: ForceField.h:56
ForceFields::UFF::Utils::calcBondForceConstant
double calcBondForceConstant(double restLength, const AtomicParams *end1Params, const AtomicParams *end2Params)
calculates and returns the UFF force constant for a bond